#!/usr/bin/python
import telnetlib
import re
import sys
import getopt
import hashlib
import time

DEBUG = False

opts, args = getopt.getopt(sys.argv[1:], "h:p:s:", ["host=", "port=", "secret="])
host = '127.0.0.1'
port = 6082
secret = '/etc/cacti/secret'
for o, v in opts:
  if o in ("-p", "--port"):
    port = int(v)
  if o in ("-h", "--host"):
    host = str(v)
  if o in ("-s", "--secret"):
    secret = str(v)

from telnetlib import Telnet
tn = Telnet(host,port)

out=tn.read_until("Authentication required.", 5)
if out != '':
    # we use challenge authentication if needed
    auth = re.search('[a-z]{32}', out)
    auth = auth.group(0)
    m = hashlib.new('sha256')
    challenge = 'e27e87a4b89b4fa3a2787ccdb7d7e041'
    auth = '%s\n' % str(auth)
    challenge = '%s\n' % str(challenge)
    m.update(auth)
    m.update(challenge)
    m.update(auth)
    key = m.hexdigest()
    key = 'auth %s\r\n' % str(key)
    tn.write(key)

tn.write('stats\r\n')
out=tn.read_until("N duplicate purges removed", 5)
tn.write('quit\r\n')
tn.close()

req = re.search("\d+  Client requests received", out)
req = req.group(0).split()[0]

hit = re.search("\d+  Cache hits", out)
hit = float(hit.group(0).split()[0])

miss = re.search("\d+  Cache misses", out)
miss = float(miss.group(0).split()[0])

if (hit + miss) != 0:
    hitrate = round(hit / (hit + miss) * 100, 1)
else:
    hitrate = 0

outstr = 'varnish_requests:%s varnish_hitrate:%s varnish_hits:%.0f varnish_misses:%.0f' % (str(req), str(hitrate), hit, miss)
print outstr
if DEBUG:
  import syslog
  outstr += "(%s)" % host
  syslog.syslog(outstr)
